(in-package #:test-upload)

(defmacro with-html-body ((&optional (title "Test Upload") &key (prologue t))  &body body)
  `(with-html-output-to-string (*standard-output* nil :prologue ,prologue)
     (hunchentoot:no-cache)
     (:html :xmlns "http://www.w3.org/1999/xhtml" ; :|xml:lang| "en" :lang "en"
      (:head
       (:title (str ,title))
       (:meta :http-equiv "Content-Type" :content "text/html; charset=UTF-8")
       (:meta :name "pragma" :content "no-cache"))
      (:body
       ,@body))))

(define-easy-handler (upload.html :uri "/hunchentoot/test-upload/upload.html")
    (img-file)
  (multiple-value-bind (img-path original-filename content-type)
      (values-list img-file)
    (with-html-body ()
      (:ul
       (:li (fmt "Image path: ~A" img-path))
       (:li (fmt "Original filename: ~A" original-filename))
       (:li (fmt "Content type: ~A" content-type))))))


(setf (hunchentoot:log-file) #+linux "/tmp/hunchentoot.log"
                             #+win32 "C:/Temp/hunchentoot.log")

(defparameter *ssl-certificate-file* #+linux "/home/ndj/web_cert.pem" #+win32 "C:/Temp/web_cert.pem")
(defparameter *ssl-privatekey-file*  #+linux "/home/ndj/web_key.pem" #+win32 "C:/Temp/web_key.pem")

(setq hunchentoot:*dispatch-table*
      (nconc (list 'hunchentoot:dispatch-easy-handlers)))

#+linux (defparameter *hunchentoot-server* (hunchentoot:start-server :port 8080 :ssl-certificate-file *ssl-certificate-file* :ssl-privatekey-file *ssl-privatekey-file*))
#+win32 (defparameter *hunchentoot-server* (hunchentoot:start-server :port 443  :ssl-certificate-file *ssl-certificate-file* :ssl-privatekey-file *ssl-privatekey-file*))
