(in-package #:cl-user)

;(hcl:extend-current-stack 100)

;;;; We will load ASDF and set the ASDF central registry in our Lisp implementation's initialization file (.lispworks for GUI or .lispworks_console for console).

;; Load swank so that we can connect to the running lisp instance with "slime-connect" / "slime-disconnect"
;(asdf:oos 'asdf:load-op :swank)      ;(load "/home/ndj/devel/cl/asdf_install_dir/site/slime-2.0/swank-loader.lisp")
;(swank:create-server :dont-close t)

;;; See LispWorks Reference Manual for proclaim to see why this is done this way.
;(defun set-compiler-options ()
;  (proclaim '(optimize (debug 3) (safety 3) (speed 0) (space 0))))

;(set-compiler-options)

;;;; Add application here:
(asdf:oos 'asdf:load-op :test-upload)

;;;; Hunchentoot setup:
(setf (hunchentoot:log-file) #+linux "/var/log/hunchentoot-sbcl.log"
                             #+win32 (prepend-dev-dir "work/phru/patient-study-db/server/db/hunchentoot.log"))
;(setf authen-ldap:*ldap-host* "info.hivsa.com")
;(setf authen-ldap:*ldap-base* "ou=People,ou=phru accounts,dc=hivsa,dc=com")
;(defparameter *ssl-certificate-file* "/etc/ssl/certs/app_cert.pem")
;(defparameter *ssl-privatekey-file*  "/etc/ssl/private/app_key.pem")
;(setf authen-ldap:*ldap-host* #+linux "davinci.hivsa.com" #+win32 "info.hivsa.com")
;(setf authen-ldap:*ldap-base* #+linux "ou=People,ou=davinci accounts,dc=hivsa,dc=com" #+win32 "ou=People,ou=phru accounts,dc=hivsa,dc=com")
(defparameter *ssl-certificate-file* #+linux "/home/ndj/devel/cl/work/phru/davinci_web_cert.pem" #+win32 (prepend-dev-dir "work/phru/patient-study-db/client/localhost_cert.pem"))
(defparameter *ssl-privatekey-file*  #+linux "/home/ndj/devel/cl/work/phru/davinci_web_key.pem" #+win32 (prepend-dev-dir "work/phru/patient-study-db/client/localhost_key.pem"))

;;;; Hunchentoot dispatch table.
;;;  Add web application dispatch tables here.
(setq hunchentoot:*dispatch-table*
      (nconc
       (list 'hunchentoot:dispatch-easy-handlers
             (hunchentoot:create-static-file-dispatcher-and-handler "/hunchentoot/site/res/phru_logo.jpg"
                                                                    #+linux
                                                                    (make-pathname :name "phru_logo" :type "jpg"
                                                                                   :directory '(:absolute "home" "ndj" "devel" "cl" "work" "phru" "site" "res")
                                                                                   :version nil)
                                                                    #+win32 (prepend-dev-dir "work/phru/site/res/phru_logo.jpg")
                                                                    "image/jpeg")
             (hunchentoot:create-static-file-dispatcher-and-handler "/hunchentoot/site/shades_of_blue.css"
                                                                    #+linux
                                                                    (make-pathname :name "shades_of_blue" :type "css"
                                                                                   :directory '(:absolute "home" "ndj" "devel" "cl" "work" "phru" "site")
                                                                                   :version nil)
                                                                    #+win32 (prepend-dev-dir "work/phru/site/shades_of_blue.css")
                                                                    "text/css"))))
;       ps-db:*patient-study-db-dt*))
;       (list (hunchentoot:create-prefix-dispatcher "/logon.html" #'html-logon:logon-page.html) #'hunchentoot:default-dispatcher)))

;(defparameter *phru-web-server* (hunchentoot:start-server :setuid "ndj" :setgid "ndj" :ssl-certificate-file *ssl-certificate-file* :ssl-privatekey-file *ssl-privatekey-file*))
#+linux (defparameter *ps-db-web-server* (hunchentoot:start-server :port 8080 :ssl-certificate-file *ssl-certificate-file* :ssl-privatekey-file *ssl-privatekey-file*))
#+win32 (defparameter *ps-db-web-server* (hunchentoot:start-server :port 443  :ssl-certificate-file *ssl-certificate-file* :ssl-privatekey-file *ssl-privatekey-file*))
(format t "Test Upload Lispworks server started!~&")
